SystemOrganization addCategory: #'SUnit-Core-Announcements'!
SystemOrganization addCategory: #'SUnit-Core-Extensions'!
SystemOrganization addCategory: #'SUnit-Core-Kernel'!
SystemOrganization addCategory: #'SUnit-Core-Utilities'!

Trait named: #TAssertable
	uses: {}
	category: 'SUnit-Core-Kernel'!

!TAssertable commentStamp: 'LaurentLaffont 4/15/2011 20:20' prior: 0!
I think it is not used yet. I think it is a Trait so that we can make things assertable and not need to subclass from TestCase for example. I may expect that TestCase uses such Trait instead of implementing all those methods,  but it is not the case. Even more, TAssertable users size -> 0. 

So...seems a work half done. Adrian Kuhn introduce it. Check
http://forum.world.st/template/NamlServlet.jtp?macro=search_page&node=1294837&query=TAssertable!

!TAssertable methodsFor: 'asserting' stamp: 'jannik.laval 5/2/2010 07:34'!
assert: aBoolean

	aBoolean ifFalse: [self signalFailure: 'Assertion failed']
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/25/2009 00:23'!
assert: aBooleanOrBlock description: aStringOrBlock
	aBooleanOrBlock value ifFalse: [
		| message |
		message := aStringOrBlock value.
		TestResult failure signal: message]
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/28/2009 20:50'!
assert: aBooleanOrBlock description: aString resumable: resumableBoolean 
	| exception |
	aBooleanOrBlock value
		ifFalse: 
			[TestResult failure new
				isResumable: resumableBoolean;
				signal: aString]
			! !

!TAssertable methodsFor: 'asserting' stamp: 'SeanDeNigris 6/23/2012 22:57'!
assert: actual equals: expected
	^ self
		assert: expected = actual
		description: (self comparingStringBetween: actual and: expected)! !

!TAssertable methodsFor: 'private' stamp: 'SeanDeNigris 6/23/2012 22:54'!
comparingStringBetween: actual and: expected
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Expected ';
			nextPutAll: (expected printStringLimitedTo: 10);
			nextPutAll: ' but was ';
			nextPutAll: (actual printStringLimitedTo: 10);
			nextPutAll: '.']! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
deny: aBooleanOrBlock

	self assert: aBooleanOrBlock value not
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
deny: aBooleanOrBlock description: aString
	self assert: aBooleanOrBlock value not description: aString
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
deny: aBooleanOrBlock description: aString resumable: resumableBoolean 
	self
		assert: aBooleanOrBlock value not
		description: aString
		resumable: resumableBoolean
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:26'!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: true]
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:26'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) ]
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:26'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) not ]
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:26'!
executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock

	^[aBlock value.
 	false] 
		on: anException
		do: [:exception | 
			anotherBlock value: exception.
			exception return: true]! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:28'!
fail

	^self assert: false! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
should: aBlock
	self assert: aBlock value
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
should: aBlock description: aString
	self assert: aBlock value description: aString
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:29'!
should: aBlock notTakeMoreThan: aDuration
    "Evaluate aBlock in a forked process and if it takes more than anInteger milliseconds
    to run we terminate the process and report a test failure.  It'' important to
    use the active process for the test failure so that the failure reporting works correctly
    in the context of the exception handlers."

    | evaluated evaluationProcess result delay testProcess |

    evaluated := false.
    delay := Delay forDuration: aDuration.
    testProcess := Processor activeProcess.
    "Create a new process to evaluate aBlock"
    evaluationProcess := [
        result := aBlock value.
        evaluated := true.
        delay unschedule.
        testProcess resume ] forkNamed: 'Process to evaluate should: notTakeMoreThanMilliseconds:'.

    "Wait the milliseconds they asked me to"
    delay wait.
    "After this point either aBlock was evaluated or not..."
    evaluated ifFalse: [
        evaluationProcess terminate.
        self assert: false description: ('Block evaluation took more than the expected <1p>' expandMacrosWith: aDuration)].
   
    ^result! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:29'!
should: aBlock notTakeMoreThanMilliseconds: anInteger
    "For compatibility with other Smalltalks"

   self should: aBlock notTakeMoreThan: (Duration milliSeconds: anInteger).! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
should: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
should: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
		description: aString
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
should: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString)
		description: aString
! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
should: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString)
		description: aString
! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:29'!
should: aBlock raise: anException withExceptionDo: anotherBlock 

	^self assert: (self executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock)! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/24/2009 01:29'!
shouldFix: aBlock 

	^self should: aBlock raise: Exception! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
shouldnt: aBlock
	self deny: aBlock value
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
shouldnt: aBlock description: aString
	self deny: aBlock value description: aString
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
shouldnt: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
shouldnt: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not 		description: aString
			! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString) not
		description: aString
! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString) not
		description: aString
! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/21/2009 14:56'!
signalFailure: aString
	TestResult failure signal: aString! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/29/2009 17:11'!
skip
	^ self skipUnless: false.! !

!TAssertable methodsFor: 'asserting' stamp: 'AdrianKuhn 12/29/2009 17:11'!
skipUnless: aBooleanOrBlock
	" If the assumption in aBooleanOrBlock is not true, abandon the running test
	and mark it as passed. "
	aBooleanOrBlock value ifFalse:
			[ TestFailure newSkipped signal: 'Assumption in #skipUnless: failed' ]! !

!Warning methodsFor: '*SUnit-Core' stamp: 'MonkeyGalactikalIntegrator 9/25/2011 19:12'!
sunitAnnounce: aTestCase toResult: aTestResult
	aTestResult addFailure: aTestCase.
	self sunitExitWith: false.! !

!Exception methodsFor: '*SUnit-Core' stamp: 'jp 3/17/2003 10:03'!
sunitExitWith: aValue
 
        self return: aValue! !

Exception subclass: #TestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

!TestFailure commentStamp: '<historical>' prior: 0!
The test framework distinguishes between failures and errors.  A failure is an event whose possibiity is explicitly anticipated and checked for in an assertion, whereas an error is an unanticipated problem like a division by 0 or an index out of bounds.  TestFailure is raised when the boolean parameter of an assert: ... or deny: ... call is the opposite of what the assertion claims.!

TestFailure subclass: #ResumableTestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

!ResumableTestFailure commentStamp: '<historical>' prior: 0!
A ResumableTestFailure triggers a TestFailure, but lets execution of the TestCase continue. this is useful when iterating through collections, and #assert: ing on each element. in combination with methods like testcase>>#assert:description:, this lets you run through a whole collection and note which tests pass.

here''s an example:

	

	(1 to: 30) do: [ :each |
		self assert: each odd description: each printString, ' is even' resumable: true]

for each element where #odd returns <false>, the element will be printed to the Transcript. !

!ResumableTestFailure methodsFor: 'camp smalltalk' stamp: ''!
isResumable
	"Of course a ResumableTestFailure is resumable ;-)"

	^true! !

!ResumableTestFailure methodsFor: 'camp smalltalk' stamp: ''!
sunitExitWith: aValue
	self resume: aValue! !

!TestFailure methodsFor: 'camp smalltalk' stamp: 'ajh 1/24/2003 19:23'!
defaultAction

	Processor activeProcess
		debug: self signalerContext
		title: self description! !

!TestFailure methodsFor: 'camp smalltalk' stamp: 'ajh 2/1/2003 00:58'!
isResumable
	
	^ false! !

!TestFailure methodsFor: 'Camp Smalltalk' stamp: ' 17/7/10 17:28'!
sunitAnnounce: aTestCase toResult: aTestResult
	aTestResult addFailure: aTestCase.
	self sunitExitWith: false! !

Announcement subclass: #TestCaseAnnouncement
	instanceVariableNames: 'testCase testSelector testResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Announcements'!

!TestCaseAnnouncement commentStamp: 'tbn 4/26/2011 09:54' prior: 0!
This is a common superclass for announcements related to SUnit test cases.

Instance Variables
        testCase:                       <TestCase>
        testResult:                     <TestResult>
        testSelector:           	   <Symbol>

testCase
        - The test case

testResult
        - The result of the test case

testSelector
        - The selector of the test method!

!TestCaseAnnouncement methodsFor: 'testing' stamp: 'tbn 4/26/2011 09:57'!
hasErrors
        "Return true if the test result has errors."
        
        ^testResult hasErrors! !

!TestCaseAnnouncement methodsFor: 'testing' stamp: 'tbn 4/26/2011 09:57'!
hasFailures
        "Return true if the test result has failures."
        
        ^testResult hasFailures! !

!TestCaseAnnouncement methodsFor: 'testing' stamp: 'tbn 4/26/2011 09:58'!
hasPassed
        "Return true if the test has passed."
        
        ^testResult hasPassed! !

!TestCaseAnnouncement methodsFor: 'accessing' stamp: 'tbn 4/26/2011 09:56'!
testCase
        "Returns the test case."
        
        ^testCase! !

!TestCaseAnnouncement methodsFor: 'accessing' stamp: 'tbn 4/26/2011 09:56'!
testCase: aTestCase
        "Sets the test case to the given test case."
        
        testCase := aTestCase! !

!TestCaseAnnouncement methodsFor: 'accessing' stamp: 'tbn 4/26/2011 09:56'!
testResult
        "Returns the test result."
        
        ^testResult! !

!TestCaseAnnouncement methodsFor: 'accessing' stamp: 'tbn 4/26/2011 09:56'!
testResult: aTestResult
        "Sets the test result to the given test result."
        
        testResult := aTestResult! !

!TestCaseAnnouncement methodsFor: 'accessing' stamp: 'tbn 4/26/2011 09:56'!
testSelector
        "Returns the test selector."
        
        ^testSelector! !

!TestCaseAnnouncement methodsFor: 'accessing' stamp: 'tbn 4/26/2011 09:57'!
testSelector: aSymbol
        "Sets the test selector to the given symbol."
        
        testSelector := aSymbol! !

TestCaseAnnouncement subclass: #TestCaseEnded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Announcements'!

!TestCaseEnded commentStamp: 'tbn 4/26/2011 09:55' prior: 0!
This event is announced when testing a test case ends.!

TestCaseAnnouncement subclass: #TestCaseStarted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Announcements'!

!TestCaseStarted commentStamp: 'tbn 4/26/2011 09:55' prior: 0!
This event is announced when testing a test case starts.!

TestCaseAnnouncement subclass: #TestSuiteEnded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Announcements'!

!TestSuiteEnded commentStamp: '<historical>' prior: 0!
This announcment is thrown when a test suite just finished (more precisly when hisoties are updated)!

!TestSuiteEnded class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 10/2/2011 17:02'!
result: aResult

	^ self new
		testResult: aResult;
		yourself! !

Object subclass: #BadEqualer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!BadEqualer commentStamp: 'mjr 8/20/2003 13:28' prior: 0!
I am an object that doesn't always report #= correctly.  Used for testing the EqualityTester.!

!BadEqualer methodsFor: 'comparing' stamp: 'mjr 8/20/2003 18:56'!
= other 
	self class = other class
		ifFalse: [^ false].
	^ 100 atRandom < 30 ! !

Object subclass: #BadHasher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!BadHasher commentStamp: 'mjr 8/20/2003 13:28' prior: 0!
I am an object that doesn't always hash correctly.  I am used for testing the HashTester.!

!BadHasher methodsFor: 'comparing' stamp: 'mjr 8/20/2003 18:56'!
hash
	"answer with a different hash some of the time"
	100 atRandom < 30
		ifTrue: [^ 1]. 
	^ 2! !

Object subclass: #ClassFactoryForTestCase
	instanceVariableNames: 'createdClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Extensions'!

!ClassFactoryForTestCase commentStamp: 'LaurentLaffont 4/15/2011 20:20' prior: 0!
I'm useful when classes needs to be created during the execution of the test. This avoid polluting your unit tests with dummy and mock classes.
A typical usage of it is:

TestCase subclass: #YourTest
       instanceVariableNames: 'classFactory'

YourTest>>setUp
       classFactory := ClassFactoryForTestCase new

YourTest>>tearDown
       classFactory deleteClasses.

YourTest>>testIsBehavior
       | cls |
       cls := classFactory newClass.
       self assert: cls isBehavior
!

!ClassFactoryForTestCase methodsFor: 'cleaning' stamp: 'Noury 10/26/2008 16:26'!
cleanUp
	| createdClassNames |
	createdClassNames := self createdClassNames.
	self deleteClasses.
	self deletePackage.
	self cleanUpChangeSetForClassNames: createdClassNames! !

!ClassFactoryForTestCase methodsFor: 'cleaning' stamp: 'Noury 10/26/2008 14:20'!
cleanUpChangeSetForClassNames: classeNames
	| changeSet |
	changeSet := ChangeSet current.
	classeNames do: [:name|
		changeSet 
			removeClassChanges: name;
			removeClassChanges: name, ' class'].	! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'Noury 10/26/2008 14:21'!
createdClassNames
	^self createdClasses collect: [:class| class name]! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'Noury 10/26/2008 13:59'!
createdClasses
	^createdClasses! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'Noury 10/26/2008 14:01'!
createdClasses: classes
	createdClasses := classes asIdentitySet ! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'Noury 10/26/2008 16:37'!
defaultCategory
	^ (self packageName , '-', self defaultCategoryPostfix) asSymbol! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'Noury 10/26/2008 16:23'!
defaultCategoryPostfix
	^ #Default! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'NouryBouraqadi 12/18/2010 18:46'!
defaultSuperclass 
	^Object! !

!ClassFactoryForTestCase methodsFor: 'cleaning' stamp: 'Noury 10/26/2008 12:47'!
delete: aClass
	aClass isObsolete ifTrue: [^self].
	aClass removeFromChanges.
	aClass removeFromSystemUnlogged
! !

!ClassFactoryForTestCase methodsFor: 'cleaning' stamp: 'Noury 10/26/2008 12:46'!
deleteClasses
	self createdClasses do: [:class|
		self delete: class]! !

!ClassFactoryForTestCase methodsFor: 'cleaning' stamp: 'Noury 10/26/2008 16:33'!
deletePackage
	| categoriesMatchString |
	categoriesMatchString := self packageName, '-*'.
	SystemOrganization removeCategoriesMatching: categoriesMatchString! !

!ClassFactoryForTestCase methodsFor: 'cleaning' stamp: 'Noury 10/26/2008 14:01'!
initialize
	super initialize.
	self createdClasses: IdentitySet new! !

!ClassFactoryForTestCase methodsFor: 'creating' stamp: 'NouryBouraqadi 12/18/2010 18:46'!
newClass
	^self newSubclassOf: self defaultSuperclass instanceVariableNames: '' classVariableNames: ''! !

!ClassFactoryForTestCase methodsFor: 'creating' stamp: 'NouryBouraqadi 12/18/2010 18:48'!
newClassInCategory: category
	^self newSubclassOf: self defaultSuperclass instanceVariableNames: '' classVariableNames: '' category: category! !

!ClassFactoryForTestCase methodsFor: 'creating' stamp: 'Noury 11/12/2009 17:53'!
newName
	| postFix |
	postFix := (self createdClasses size + 1) printString.
	^(#ClassForTestToBeDeleted, postFix) asSymbol! !

!ClassFactoryForTestCase methodsFor: 'creating' stamp: 'Noury 10/26/2008 16:25'!
newSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString 
	^self 
		newSubclassOf: aClass 
		instanceVariableNames: ivNamesString 
		classVariableNames: classVarsString 
		category: self defaultCategoryPostfix! !

!ClassFactoryForTestCase methodsFor: 'creating' stamp: 'Noury 10/26/2008 16:36'!
newSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category
	| newClass |
	newClass := aClass 
		subclass: self newName 
		instanceVariableNames: ivNamesString 
		classVariableNames: classVarsString 
		poolDictionaries: '' 
		category: (self packageName, '-', category) asSymbol.
	self createdClasses add: newClass.
	^newClass! !

!ClassFactoryForTestCase methodsFor: 'accessing' stamp: 'Noury 10/26/2008 16:20'!
packageName
	^#CategoryForTestToBeDeleted! !

ClassFactoryForTestCase subclass: #ClassFactoryWithOrganization
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Extensions'!

!ClassFactoryWithOrganization commentStamp: 'LaurentLaffont 5/4/2011 21:25' prior: 0!
I'm a class to create classes with a category. I'm only used by Tests.

I am similar to ClassFactoryForTestCase (i.e., I can be used in place of a ClassFactoryForTestCase), expect that classes may be created on a specific class category.!

!ClassFactoryWithOrganization class methodsFor: 'instance creation' stamp: 'LucFabresse 10/24/2010 20:33'!
newWithOrganization: aSystemOrganizer
	^self new
		organization: aSystemOrganizer;
		yourself! !

!ClassFactoryWithOrganization methodsFor: 'cleaning' stamp: 'LucFabresse 10/24/2010 22:01'!
deletePackage
	| categoriesMatchString |
	categoriesMatchString := self packageName, '-*'.
	self organization removeCategoriesMatching: categoriesMatchString ; 
		removeEmptyCategories
	! !

!ClassFactoryWithOrganization methodsFor: 'creating' stamp: 'LucFabresse 10/29/2010 08:04'!
newClassNamed: aString subclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString 
	^self 
		newClassNamed: aString
		subclassOf: aClass 
		instanceVariableNames: ivNamesString 
		classVariableNames: classVarsString 
		category:  (self packageName, '-', self defaultCategoryPostfix) asSymbol.! !

!ClassFactoryWithOrganization methodsFor: 'creating' stamp: 'LucFabresse 10/29/2010 08:03'!
newClassNamed: aString subclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category
	| newClass |
	newClass := (ClassBuilder new)
		name: aString 
		inEnvironment: self organization environment
		subclassOf: aClass
		type: aClass typeOfClass
		instanceVariableNames: ivNamesString
		classVariableNames: classVarsString
		poolDictionaries: ''
		category: category asSymbol.
	self createdClasses add: newClass.
	^newClass! !

!ClassFactoryWithOrganization methodsFor: 'creating' stamp: 'LucFabresse 10/24/2010 21:41'!
newSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString 
	^self 
		newSubclassOf: aClass 
		instanceVariableNames: ivNamesString 
		classVariableNames: classVarsString 
		category:  (self packageName, '-', self defaultCategoryPostfix) asSymbol.! !

!ClassFactoryWithOrganization methodsFor: 'creating' stamp: 'LucFabresse 10/24/2010 21:35'!
newSubclassOf: aClass instanceVariableNames: ivNamesString classVariableNames:  classVarsString category: category

	| newClass |
	newClass := (ClassBuilder new)
		name: self newName 
		inEnvironment: self organization environment
		subclassOf: aClass
		type: aClass typeOfClass
		instanceVariableNames: ivNamesString
		classVariableNames: classVarsString
		poolDictionaries: ''
		category: category asSymbol.
	self createdClasses add: newClass.
	^newClass! !

!ClassFactoryWithOrganization methodsFor: 'accessing' stamp: 'LucFabresse 10/24/2010 20:31'!
organization
	^organization! !

!ClassFactoryWithOrganization methodsFor: 'accessing' stamp: 'LucFabresse 10/24/2010 20:31'!
organization: aSystemOrganizer
	organization := aSystemOrganizer! !

Object subclass: #PrototypeTester
	instanceVariableNames: 'prototype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!PrototypeTester commentStamp: 'mjr 8/20/2003 13:09' prior: 0!
I am a simple holder of a prototype object and hand out copies when requested.!

PrototypeTester subclass: #EqualityTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!EqualityTester commentStamp: 'mjr 8/20/2003 13:04' prior: 0!
I provide a simple way to test the equality properties of any object.!

!EqualityTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
resultFor: runs 
	"Test that equality is the same over runs and answer the result"
	1
		to: runs
		do: [:i | self prototype = self prototype
				ifFalse: [^ false]]. 
	^ true! !

PrototypeTester subclass: #HashTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!HashTester commentStamp: 'mjr 8/20/2003 12:48' prior: 0!
I provide a simple way to test the hash properties of any object.  

I am given an object that should be tested and I treat it like a prototype.  I take a copy of it when I am given it so that it can't change whilst I am holding on to it.  I can then test that multiple copies of this object all hash to the same value.!

!HashTester methodsFor: 'as yet unclassified' stamp: 'stephaneducasse 2/3/2006 22:39'!
resultFor: runs 
	"Test that the hash is the same over runs and answer the result"
	| hash |
	hash := self prototype hash.
	1
		to: runs
		do: [:i | hash = self prototype hash
				ifFalse: [^ false]].
	^ true ! !

!PrototypeTester class methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 13:08'!
defaultRuns
"the default number of times to test"
	^ 50! !

!PrototypeTester class methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 13:08'!
with: aPrototype
	^self new prototype:aPrototype! !

!PrototypeTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
prototype
	"Get a prototype"
	^ prototype copy ! !

!PrototypeTester methodsFor: 'as yet unclassified' stamp: 'stephaneducasse 2/3/2006 22:39'!
prototype: aPrototype 
	"Set my prototype"
	prototype := aPrototype copy ! !

!PrototypeTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:57'!
result
	"Perform the test the default number of times"
	^ self resultFor: self class defaultRuns ! !

Object subclass: #SUnitUnloader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!SUnitUnloader commentStamp: 'LaurentLaffont 4/15/2011 20:20' prior: 0!
I am SUnitUnloader, a little tool to unload SUnit and a fixed set of Tests from the current image.

Usage: SUnitUnloader new unloadAll

Caveat: #unloadTestPackages uses a fixed and probably ill maintained list of what packages hold unit tests.
!

!SUnitUnloader methodsFor: 'unloading' stamp: 'GuillermoPolito 5/22/2010 21:33'!
unloadAll
	self unloadTestPackages.
	self unloadSUnit.! !

!SUnitUnloader methodsFor: 'unloading' stamp: 'MarcusDenker 2/21/2012 14:46'!
unloadSUnit
	Smalltalk globals
		at: #TestCase
		ifPresent: [ :class | SystemChangeNotifier uniqueInstance noMoreNotificationsFor: class ].
	#('SUnit-Tests' 'SUnit-UI' 'SUnit-Core' 'SUnit-Help') do: [ :each | (MCPackage named: each) unload ].
	AppRegistry removeObsolete.	! !

!SUnitUnloader methodsFor: 'unloading' stamp: 'MarcusDenker 4/6/2012 10:23'!
unloadTestPackages
        #('Tests' 'CollectionsTests' 'CompilerTests' 'BalloonTests' 'FreeTypeTests' 'Graphics-Tests' 'KernelTests' 'MorphicTests' 'MultilingualTests' 'NetworkTests' 'ToolsTest' 'Gofer-Tests' 'Announcements-Tests-Core' 'CompressionTests' 'HelpSystem-Tests' 'Multilingual-Tests' 'Regex-Tests-Core' 'HelpSystem-Tests'  'Balloon-Collections-Tests' 'StratifiedProxy-Tests' 'Finder-Tests' 'Zinc-Tests' 'Ring-Tests-Kernel'
'Ring-Tests-Containers' 'ShoutTests'  'FileSystem-Tests-Memory' 'FileSystem-Tests-Disk' 'FileSystem-Tests-Core' 'FileSystem-Tests-AnsiStreams' )
                do: [ :each | (MCPackage named: each) unload ]. 
! !

Object subclass: #TestAsserter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

!TestAsserter commentStamp: '<historical>' prior: 0!
I understand methods beginning #assert:... and #deny:... (and my class-side understands #assert:description:).  I am the superclass of TestCase and TestResource and can also be the superclass of any test helper classes you create to factor out test behaviour.  I exist so that test code can be refactored between my subclasses without difficulty.

Send #assert:description: when you want to check for an expected value. For example, you might say
	self assert: socket isOpen description: 'We requested a socket but now it is not open'.
to test whether or not a socket is open at a point in a test.  Use description strings both to give more information about where a test failed in debugger notifiers and logs, and to document the intent of a test.  Other methods include #assert:, #assert:description:resumable:, #deny:, #deny:description:, #deny:description:resumable:, #should:raise:, #should:raise:description:, #shouldnt:raise:, #shouldnt:raise:description:.  All these methods are defined on the superclass, TestAsserter.  (Any convenience assertion methods you create for general use should also be defined in my 'convenience' protocol.)

Override my class-side #isLogging in subclasses to have failed assertion descriptions shown on the Transcript.  To have them appear elsewhere, also override my class-side #failureLog.
!

!TestAsserter class methodsFor: 'asserting' stamp: 'NiallRoss 7/18/2010 16:16'!
assert: aBoolean description: aString
	"Minimal clone of the instance-side assert protocol so that class-side methods can use it."

	aBoolean ifFalse:
		[self logFailure: aString.
		TestResult failure signal: aString].! !

!TestAsserter class methodsFor: 'logging' stamp: 'NiallRoss 7/18/2010 11:48'!
failureLog
	^Transcript! !

!TestAsserter class methodsFor: 'logging' stamp: 'BaseSystem 8/30/2009 09:35'!
isLogging
	"By default, we're not logging failures. Override in subclasses as desired."

	^false! !

!TestAsserter class methodsFor: 'logging' stamp: 'BaseSystem 8/30/2009 09:35'!
logFailure: aString
	self isLogging ifTrue:
		[self failureLog cr; nextPutAll: aString; flush].! !

!TestAsserter methodsFor: 'asserting' stamp: 'NiallRoss 7/18/2010 16:15'!
assert: aBoolean
	aBoolean ifFalse:
		[self logFailure: 'Assertion failed'.
		TestResult failure signal: 'Assertion failed'].! !

!TestAsserter methodsFor: 'asserting' stamp: 'NiallRoss 7/18/2010 16:16'!
assert: aBoolean description: aString
	aBoolean ifFalse:
		[self logFailure: aString.
		TestResult failure signal: aString].! !

!TestAsserter methodsFor: 'asserting' stamp: 'NiallRoss 7/18/2010 16:16'!
assert: aBoolean description: aString resumable: resumableBoolean
	| exception |
	aBoolean ifFalse:
		[self logFailure: aString.
		exception := resumableBoolean
			ifTrue: [TestResult resumableFailure]
			ifFalse: [TestResult failure].
		exception signal: aString].! !

!TestAsserter methodsFor: 'convenience' stamp: 'nfr 1/3/2010 18:38'!
assert: anObject equals: anotherObject
	self
		assert: anObject = anotherObject
		description: anObject printString , ' is not equal to ' , anotherObject printString.! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
deny: aBoolean
	self assert: aBoolean not.! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
deny: aBoolean description: aString
	self assert: aBoolean not description: aString.! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
deny: aBoolean description: aString resumable: resumableBoolean
	self assert: aBoolean not description: aString resumable: resumableBoolean.! !

!TestAsserter methodsFor: 'private' stamp: 'NiallRoss 7/18/2010 11:55'!
executeShould: aBlock inScopeOf: anExceptionalEvent
	^[aBlock value.
 	false]
		on: anExceptionalEvent
		do: [:ex | ex sunitExitWith: true]! !

!TestAsserter methodsFor: 'logging' stamp: 'BaseSystem 8/30/2009 09:35'!
logFailure: aString
	self class logFailure: aString.! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
should: aBlock raise: anExceptionalEvent 
	self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent).! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
should: aBlock raise: anExceptionalEvent description: aString 
	self
		assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
		description: aString.! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
shouldnt: aBlock raise: anExceptionalEvent 
	self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not.! !

!TestAsserter methodsFor: 'asserting' stamp: 'BaseSystem 8/30/2009 09:35'!
shouldnt: aBlock raise: anExceptionalEvent description: aString 
	self
		assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not
 		description: aString.! !

TestAsserter subclass: #TestCase
	instanceVariableNames: 'testSelector expectedFails'
	classVariableNames: 'Announcers'
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

TestCase class
	instanceVariableNames: 'history'!

!TestCase commentStamp: 'nfr 1/3/2010 17:56' prior: 0!
A TestCase is an implementation of the Command pattern to run a test.  TestCase instances are created with the class method #selector:, passing the symbol that names the method to be executed when the test case runs.  Various UIs exist to run these instances and they can also be created and run programmatically.

When you discover a new fixture, subclass TestCase and create a #test... method for the first test.  As that method develops and more #test... methods are added, you will find yourself refactoring temps into instance variables for the objects in the fixture and overriding #setUp to initialize these variables.  As required, override #tearDown to nil references, release objects and deallocate.

See my superclass' comment for assertion and logging information.!

TestCase class
	instanceVariableNames: 'history'!

TestCase subclass: #ClassTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!ClassTestCase commentStamp: 'brp 7/26/2003 16:57' prior: 0!
This class is intended for unit tests of individual classes and their metaclasses.

It provides methods to determine the coverage of the unit tests.

Subclasses are expected to re-implement #classesToBeTested and #selectorsToBeIgnored.

They should also implement to confirm that all methods have been tested.

#testCoverage

	super testCoverage.

!

!ClassTestCase class methodsFor: 'testing' stamp: 'md 2/22/2006 14:21'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #ClassTestCase
			! !

!ClassTestCase class methodsFor: 'testing' stamp: 'brp 12/14/2003 15:50'!
mustTestCoverage

	^ false! !

!ClassTestCase methodsFor: 'private' stamp: 'md 1/28/2004 11:32'!
categoriesForClass: aClass

 ^ aClass organization allMethodSelectors collect: 
			[:each |  aClass organization categoryOfElement: each].
! !

!ClassTestCase methodsFor: 'coverage' stamp: 'brp 7/27/2003 12:39'!
classToBeTested
	
	self subclassResponsibility! !

!ClassTestCase methodsFor: 'coverage' stamp: 'brp 7/26/2003 16:35'!
selectorsNotTested

	^ self selectorsToBeTested difference: self selectorsTested.
! !

!ClassTestCase methodsFor: 'coverage' stamp: 'MarcusDenker 3/5/2010 14:33'!
selectorsTested
	| literals |
	literals := Set new.
	self class
		selectorsAndMethodsDo: [ :s :m | (s beginsWith: 'test')
			ifTrue: [ literals addAll: (m messages)] ].
	^ literals asArray sort! !

!ClassTestCase methodsFor: 'coverage' stamp: 'brp 7/26/2003 17:22'!
selectorsToBeIgnored
	^ #(#DoIt #DoItIn:)! !

!ClassTestCase methodsFor: 'coverage' stamp: 'brp 7/27/2003 12:40'!
selectorsToBeTested

	^ ( { self classToBeTested. self classToBeTested class } gather: [:c | c selectors]) 
			difference: self selectorsToBeIgnored! !

!ClassTestCase methodsFor: 'private' stamp: 'lr 3/14/2010 21:13'!
targetClass
	[ ^ self classToBeTested ]
		on: Error
		do: [ 
			| className |
			className := self class name asText copyFrom: 0 to: self class name size - 4.
			^ Smalltalk globals at: className asString asSymbol ]! !

!ClassTestCase methodsFor: 'tests' stamp: 'marcus.denker 7/29/2009 15:27'!
testClassComment
	self should: [self targetClass organization hasComment].! !

!ClassTestCase methodsFor: 'tests' stamp: 'brp 12/14/2003 15:51'!
testCoverage

	| untested | 
	self class mustTestCoverage ifTrue:
		[ untested := self selectorsNotTested.
		self assert: untested isEmpty 
		description: untested size asString, ' selectors are not covered' ]! !

!ClassTestCase methodsFor: 'tests' stamp: 'md 3/25/2003 23:07'!
testNew
	self shouldnt: [self targetClass new] raise: Error.! !

!ClassTestCase methodsFor: 'tests' stamp: 'md 3/26/2003 17:24'!
testUnCategorizedMethods
	| categories slips  |
	categories := self categoriesForClass: self targetClass.
	slips := categories select: [:each | each = #'as yet unclassified'].
	self should: [slips isEmpty].	! !

TestCase subclass: #HashAndEqualsTestCase
	instanceVariableNames: 'prototypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!HashAndEqualsTestCase commentStamp: 'mjr 8/20/2003 17:37' prior: 0!
I am a simple TestCase that tests for correct operation of #hash and #=.

Subclasses of me need to fill my prototypes with suitable objects to be tested.!

!HashAndEqualsTestCase methodsFor: 'running' stamp: 'stephaneducasse 2/3/2006 22:39'!
setUp
	"subclasses will add their prototypes into this collection"
	prototypes := OrderedCollection new ! !

!HashAndEqualsTestCase methodsFor: 'testing' stamp: 'mjr 8/20/2003 18:56'!
testEquality
	"Check that TextFontChanges report equality correctly"
	prototypes
		do: [:p | self
				should: [(EqualityTester with: p) result]] ! !

!HashAndEqualsTestCase methodsFor: 'testing' stamp: 'al 6/12/2008 21:58'!
testHash
	"test that TextFontChanges hash correctly"
	prototypes do: [:p |
		self should: [(HashTester with: p) result]] ! !

TestCase subclass: #HashTesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!HashTesterTest commentStamp: 'mjr 8/20/2003 12:48' prior: 0!
I am a simple test case to check that HashTester works correctly!

!HashTesterTest methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
testBasicBehaviour
	self
		should: [(HashTester with: 1)
				resultFor: 100].
	self
		should: [(HashTester with: 'fred')
				resultFor: 100].
	self
		shouldnt: [(HashTester with: BadHasher new)
				resultFor: 100] ! !

TestCase subclass: #LongTestCase
	instanceVariableNames: ''
	classVariableNames: 'RunLongTestCases'
	poolDictionaries: ''
	category: 'SUnit-Core-Extensions'!

!LongTestCase commentStamp: 'DamirLaurent 5/2/2011 22:17' prior: 0!
I'm a TestCase which takes time to run. I can be disabled using #doNotRunLongTestCases and enabled again using #runLongTestCases.

Tests that are long should be subclasses of myself.

I also provide a setting for the SettingsBrowser!

!LongTestCase class methodsFor: 'accessing' stamp: 'StephaneDucasse 10/18/2010 14:02'!
allTestSelectors
	self shouldRun ifTrue: [
		^super testSelectors].
	^#().! !

!LongTestCase class methodsFor: 'instance creation' stamp: 'StephaneDucasse 10/18/2010 14:02'!
buildSuite

	| suite |
	suite := self suiteClass new.
	self shouldRun ifTrue: [
		self addToSuiteFromSelectors: suite].
	^suite! !

!LongTestCase class methodsFor: 'accessing' stamp: 'StephaneDucasse 10/18/2010 12:21'!
doNotRunLongTestCases
	"Tells the system that long tests should not be run"
	
	self shouldRun: false! !

!LongTestCase class methodsFor: 'initialization' stamp: 'DamirLaurent 5/2/2011 21:32'!
initialize

	self runLongTestCases! !

!LongTestCase class methodsFor: 'testing' stamp: 'md 2/22/2006 14:21'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #LongTestCase
			! !

!LongTestCase class methodsFor: 'accessing' stamp: 'StephaneDucasse 10/18/2010 12:21'!
runLongTestCases
	"Tell the system that long tests should be run"
	
	self shouldRun: true.! !

!LongTestCase class methodsFor: 'settings' stamp: 'DamirLaurent 5/2/2011 21:59'!
runLongTestsSettingOn: aBuilder
	<systemsettings>
	
	(aBuilder setting: #shouldRun)
		target: self;
		parent: #pharoSystem;
		label: 'Run Long Tests' translated;
		description: 'Whether to run long SUnit TestCase. Tests which take long time to run should be subclasses of LongTestCase.' translated.! !

!LongTestCase class methodsFor: 'accessing' stamp: 'DamirLaurent 5/2/2011 21:33'!
shouldRun
	"Return whether long tests should be run or not"
	
	RunLongTestCases ifNil: [self runLongTestCases].
	^ RunLongTestCases ! !

!LongTestCase class methodsFor: 'accessing' stamp: 'StephaneDucasse 10/18/2010 12:21'!
shouldRun: aBoolean
	"Set whether long tests should be run or not"
	
	RunLongTestCases := aBoolean! !

LongTestCase subclass: #LongTestCaseTestUnderTest
	instanceVariableNames: ''
	classVariableNames: 'RunStatus'
	poolDictionaries: ''
	category: 'SUnit-Core-Extensions'!

!LongTestCaseTestUnderTest class methodsFor: 'accessing' stamp: 'sd 9/25/2004 14:02'!
hasRun

	^ RunStatus! !

!LongTestCaseTestUnderTest class methodsFor: 'accessing' stamp: 'md 11/14/2004 21:37'!
markAsNotRun

	^ RunStatus := false! !

!LongTestCaseTestUnderTest methodsFor: 'testing' stamp: 'md 11/14/2004 21:30'!
testWhenRunMarkTestedToTrue


	RunStatus := true.! !

TestCase subclass: #LongTestCaseTest
	instanceVariableNames: 'longTestCaseSettingValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Extensions'!

!LongTestCaseTest methodsFor: 'setup' stamp: 'StephaneDucasse 10/18/2010 12:19'!
setUp

	longTestCaseSettingValue := LongTestCase shouldRun! !

!LongTestCaseTest methodsFor: 'setup' stamp: 'StephaneDucasse 10/18/2010 12:20'!
tearDown

	LongTestCase shouldRun: longTestCaseSettingValue! !

!LongTestCaseTest methodsFor: 'testing' stamp: 'StephaneDucasse 10/18/2010 14:02'!
testLongTestCaseDoNotRun
	"self debug: #testLongTestCaseDoNotRun"
	"self run: #testLongTestCaseDoNotRun"

	LongTestCase doNotRunLongTestCases.
	LongTestCaseTestUnderTest markAsNotRun.
	self deny: LongTestCaseTestUnderTest hasRun.
	LongTestCaseTestUnderTest suite run.
	self deny: LongTestCaseTestUnderTest hasRun.


	! !

!LongTestCaseTest methodsFor: 'testing' stamp: 'md 12/5/2004 21:28'!
testLongTestCaseRun
	"self debug: #testLongTestCaseRun"
	"self run: #testLongTestCaseRun"

	LongTestCase runLongTestCases.
	LongTestCaseTestUnderTest markAsNotRun.
	self deny: LongTestCaseTestUnderTest hasRun.
	LongTestCaseTestUnderTest suite run.
	self assert: LongTestCaseTestUnderTest hasRun.
	LongTestCase doNotRunLongTestCases.

	! !

TestCase subclass: #PackageDependencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Utilities'!

!PackageDependencyTest methodsFor: 'test utility' stamp: 'Alexandre Bergel 5/22/2010 15:38'!
dependenciesOfPackageNamed: pkgNameAsString
	| deps classes |
	classes := self referencesInPackageNamed: pkgNameAsString.

	deps := Dictionary new.
	classes
		do: [:aClass | 
			| pkg |
			pkg := PackageOrganizer default
						packageOfClass: aClass
						ifNone: [].
			pkg
				ifNil: [Transcript cr; show: 'WARNING: No package for ' , pkg]
				ifNotNil: [(deps
							at: pkg packageName
							ifAbsentPut: [OrderedCollection new])
						  add: aClass]].
	deps
		removeKey: pkgNameAsString
		ifAbsent: [].
	^ deps! !

!PackageDependencyTest methodsFor: 'test utility' stamp: 'Alexandre Bergel 5/22/2010 15:47'!
referencesInClass: aClass
	| classes |
	classes := IdentitySet new.
	aClass isTrait
		ifFalse: [ classes add: aClass superclass ].
	
	"The following line is wrong because methods may be defined in a different package"
	"aClass methods do: [ :cm | classes addAll: (self referencesInCompiledMethod: cm) ]."
	^ classes! !

!PackageDependencyTest methodsFor: 'test utility' stamp: 'Alexandre Bergel 5/22/2010 15:32'!
referencesInCompiledMethod: aCompiledMethod
	| classes |
	classes := IdentitySet new.
	1
		to: aCompiledMethod numLiterals
		do: [:i | | lit | ((lit := aCompiledMethod literalAt: i) isVariableBinding
							and: [  lit value isBehavior ])
						ifTrue: [classes add: lit value ]].
	^ classes! !

!PackageDependencyTest methodsFor: 'test utility' stamp: 'Alexandre Bergel 5/22/2010 15:43'!
referencesInPackage: aPackageInfo
	| classes |
	classes := IdentitySet new.
	aPackageInfo classes do: [ :cls | classes addAll: (self referencesInClass: cls) ].
	aPackageInfo methods do: [ :mr | classes addAll: (self referencesInCompiledMethod: mr compiledMethod )].
	^ classes! !

!PackageDependencyTest methodsFor: 'test utility' stamp: 'Alexandre Bergel 5/22/2010 15:33'!
referencesInPackageNamed: pkgNameAsString
	| pi |
	pi := PackageOrganizer default
				packageNamed: pkgNameAsString
				ifAbsent: [^ self].

	^ self referencesInPackage: pi! !

!PackageDependencyTest methodsFor: 'test utility' stamp: 'StephaneDucasse 9/9/2010 14:50'!
testPackage: pkgName dependsExactlyOn: pkgList
	"Ensure that the package with the given name depends only on the packages in pkgList.
	NOTE: If you use this for fixing dependencies, classDeps includes the classes
	and users from the package(s) not declared as dependents. Basically, you need
	to fix all the references in classDeps to make the test pass."
	
	| classDeps pi pkgDeps |
	classDeps := IdentityDictionary new.
	pi := PackageOrganizer default packageNamed: pkgName ifAbsent:[^self]. "unloaded"
	pi classes do: [ :pkgClass | 
		(classDeps at: (pkgClass superclass ifNil: [ProtoObject]) 
			ifAbsentPut:[OrderedCollection new]) add: pkgClass name, ' superclass'.].
	pi methods do: [ :mref | | cm |
		cm := mref compiledMethod.
		1 to: cm numLiterals do: [ :i | | lit |
			((lit := cm literalAt: i) isVariableBinding 
				and:[lit value isBehavior]) ifTrue:[(classDeps at: lit value ifAbsentPut:[OrderedCollection new]) add: cm methodClass asString, '>>', cm selector]]].
	pkgDeps := Dictionary new.
	classDeps keys do: [ :aClass | | pkg |
		pkg := PackageOrganizer default packageOfClass: aClass ifNone:[nil].
		pkg ifNil: [
				Transcript cr; show: 'WARNING: No package for ', aClass.
				(classDeps removeKey: aClass) do:[:each| Transcript crtab; show: each]] 
			ifNotNil: [(pkgDeps at: pkg name ifAbsentPut:[OrderedCollection new]) add: aClass]].
	(pkgDeps removeKey: pkgName ifAbsent: [#()]) 
		do: [ :aClass | classDeps removeKey: aClass ifAbsent: []].
	pkgList do: [ :pkg |
		self assert: (pkgDeps includesKey: pkg) description: pkgName, ' no longer depends on ', pkg.
		(pkgDeps removeKey: pkg ifAbsent: [#()]) 
			do: [ :aClass | classDeps removeKey: aClass ifAbsent:[]]].
		
	classDeps keysAndValuesDo: [ :class :deps |
		Transcript cr; show: class name, ' dependencies:'.
		deps do: [ :each | Transcript crtab; show: each]].
	self assert: pkgDeps isEmpty
		description: pkgName, ' now depends on ', pkgDeps.
! !

!PackageDependencyTest methodsFor: 'test utility' stamp: 'Alexandre Bergel 5/22/2010 15:36'!
testPackage: pkgName dependsOnlyOn: pkgList 
	"Ensure that the package with the given name depends only on the
	packages in pkgList"
	| classes pi deps |
	
	deps := self dependenciesOfPackageNamed: pkgName.

	pkgList
		do: [:pkg | 
			self
				assert: (deps includesKey: pkg).
			deps removeKey: pkg].

	self assert: deps isEmpty! !

!TestCase class methodsFor: 'building suites' stamp: 'lr 3/14/2010 21:13'!
addTestsFor: classNameString toSuite: suite
	| cls |
	cls := Smalltalk globals at: classNameString ifAbsent: [ ^ suite ].
	^ cls isAbstract
		ifTrue: [ 
			cls allSubclasses
				do: [ :each | 
					each isAbstract
						ifFalse: [ each addToSuiteFromSelectors: suite ] ].
			suite ]
		ifFalse: [ cls addToSuiteFromSelectors: suite ]! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 4/21/2002 10:51'!
addToSuite: suite fromMethods: testMethods 
	testMethods do:  [ :selector | 
			suite addTest: (self selector: selector) ].
	^suite! !

!TestCase class methodsFor: 'building suites' stamp: 'nk 4/21/2002 16:37'!
addToSuiteFromSelectors: suite
	^self addToSuite: suite fromMethods: (self shouldInheritSelectors
		ifTrue: [ self allTestSelectors ]
		ifFalse: [self testSelectors ])! !

!TestCase class methodsFor: 'accessing' stamp: ' 17/7/10 17:28'!
allTestSelectors
	| answer pivotClass lookupRoot |
	answer := Set withAll: self testSelectors.
	self shouldInheritSelectors
		ifTrue:
			[pivotClass := self.
			lookupRoot := self lookupHierarchyRoot.
			[pivotClass == lookupRoot]
				whileFalse:
					[pivotClass := pivotClass superclass.
					answer addAll: pivotClass testSelectors]].
	^answer asSortedCollection asOrderedCollection! !

!TestCase class methodsFor: 'events' stamp: 'Alexandre Bergel 7/29/2010 14:37'!
announcer 
	^ self announcers at: self ifAbsentPut: [ Announcer new ]! !

!TestCase class methodsFor: 'events' stamp: 'jannik.laval 10/1/2010 17:20'!
announcers
	^ Announcers ifNil: [ Announcers := Dictionary new ] ! !

!TestCase class methodsFor: 'building suites' stamp: 'BaseSystem 8/30/2009 09:35'!
buildSuite
	| suite |
	^self isAbstract
		ifTrue: 
			[suite := self suiteClass named: self name asString.
			self allSubclasses 
				do: [:each | each isAbstract ifFalse: [suite addTest: each buildSuiteFromSelectors]].
			suite]
		ifFalse: [self buildSuiteFromSelectors]! !

!TestCase class methodsFor: 'building suites' stamp: ''!
buildSuiteFromAllSelectors

	^self buildSuiteFromMethods: self allTestSelectors
			! !

!TestCase class methodsFor: 'building suites' stamp: ''!
buildSuiteFromLocalSelectors

	^self buildSuiteFromMethods: self testSelectors
			! !

!TestCase class methodsFor: 'building suites' stamp: 'BaseSystem 8/30/2009 09:35'!
buildSuiteFromMethods: testMethods

	^testMethods
		inject: (self suiteClass named: self name asString)
		into: [:suite :selector |
			suite
				addTest: (self selector: selector);
				yourself]! !

!TestCase class methodsFor: 'building suites' stamp: ' 17/7/10 17:28'!
buildSuiteFromSelectors
	^self buildSuiteFromMethods: self allTestSelectors! !

!TestCase class methodsFor: 'coverage' stamp: 'lr 3/14/2010 21:13'!
coverage
	"returns the coverage determined by a simple static analysis of test coverage 
	made by the receiver on a class that is identified by the name of the receiver.
	We assume that SetTest test Set."

	| cls className |
	(self name endsWith: 'Test')
		ifFalse: [ self error: 'Please, use #coverageForClass: instead' ].
	className := self name copyFrom: 1 to: self name size - 'Test' size.
	cls := Smalltalk globals at: className asSymbol ifAbsent: [ self error: 'Please, use #coverageForClass: instead' ].	"May happen with Transcript"
	cls isBehavior
		ifFalse: [ cls := cls class ].
	^ self coverageForClass: cls! !

!TestCase class methodsFor: 'coverage' stamp: 'ab 12/25/2008 17:20'!
coverageAsString
	| cov className |
	cov := self coverage first asInteger. 
	"coverage already checks that the name is ends with 'Test' and if the class tested exists"
	
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	^ self name asString, ' covers ', cov asString, '% of ', className.! !

!TestCase class methodsFor: 'coverage' stamp: 'sd 1/28/2009 14:57'!
coverageForClass: cls
	"returns the test coverage of all the methods included inherited ones"
	^ self coverageForClass: cls until: ProtoObject! !

!TestCase class methodsFor: 'coverage' stamp: 'sd 1/28/2009 14:58'!
coverageForClass: cls until: aRootClass
	"returns the test coverage of all the methods included inherited ones but stopping at aRootClass included"
	
	| definedMethods testedMethods untestedMethods |
	definedMethods := cls allSelectorsAboveUntil: aRootClass.
	definedMethods size = 0
		ifTrue: [^ {0. Set new}].
	testedMethods := 
		self methodDictionary values inject: Set new into: 
							[:sums :cm | sums union: cm messages].
	testedMethods := testedMethods reject: [:sel | (definedMethods includes: sel) not].
	untestedMethods := definedMethods select: [:selector | (testedMethods includes: selector) not].
	^ { (testedMethods size * 100 / definedMethods size) asFloat . untestedMethods}
! !

!TestCase class methodsFor: 'coverage' stamp: 'ab 12/25/2008 17:15'!
coveragePercentage
	^ self coverage first! !

!TestCase class methodsFor: 'instance creation' stamp: 'BaseSystem 8/30/2009 09:35'!
debug: aSymbol

	^(self selector: aSymbol) debug! !

!TestCase class methodsFor: 'history' stamp: 'simon.denier 11/13/2008 19:22'!
generateLastStoredRunMethod

	self shouldGenerateLastStoredRunMethod ifTrue: [
		self class
			compile: (self lastRunMethodNamed: #lastStoredRun)
			classified: 'history' ]! !

!TestCase class methodsFor: 'testing' stamp: 'Alexandre.Bergel 4/3/2009 15:06'!
hasMethodBeenRun: aSelector
	^ ((self lastRun at: #errors),
		(self lastRun at: #failures),
		(self lastRun at: #passed))
			includes: aSelector! !

!TestCase class methodsFor: 'history' stamp: 'Alexandre.Bergel 4/3/2009 14:57'!
history
	^ history ifNil: [ history := self newTestDictionary ]! !

!TestCase class methodsFor: 'history' stamp: 'BenjaminVanRyseghem 10/2/2011 17:00'!
history: aDictionary

	history := aDictionary.
	TestAnnouncer announcer announce: (TestSuiteEnded result: self)! !

!TestCase class methodsFor: 'initialize - event' stamp: 'AlexandreBergel 10/22/2008 13:31'!
initialize
     super initialize.
	SystemChangeNotifier uniqueInstance notify: self ofSystemChangesOfItem: #method using: #methodChanged:.! !

!TestCase class methodsFor: 'testing' stamp: 'md 2/22/2006 14:21'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #TestCase
			! !

!TestCase class methodsFor: 'testing' stamp: 'JorgeRessia 3/16/2010 20:06'!
isUnitTest
	^true! !

!TestCase class methodsFor: 'history' stamp: 'simon.denier 11/22/2008 20:56'!
lastRun
	^ TestResult historyFor: self! !

!TestCase class methodsFor: 'history' stamp: 'simon.denier 11/13/2008 19:21'!
lastRunMethodNamed: aSelector
	
	^ String streamContents: [:str |
		str nextPutAll: aSelector asString ;cr.
		str tab; nextPutAll: '^ ', (self lastRun) storeString]
! !

!TestCase class methodsFor: 'history' stamp: 'AlexandreBergel 10/22/2008 10:33'!
lastStoredRun
	^ ((Dictionary new) add: (#failures->#()); add: (#passed->#()); add: (#errors->#()); yourself)! !

!TestCase class methodsFor: 'coverage' stamp: 'lr 3/14/2010 21:13'!
localCoverage
	"returns the coverage determined by a simple static analysis of test coverage 
	made by the receiver on a class that is identified by the name of the receiver.
	We assume that SetTest test Set. The computation of the coverage takes only into
	account the methods defined locally in the tested class. See coverage for a more global 
	coverage"

	| cls className |
	(self name endsWith: 'Test')
		ifFalse: [ self error: 'Please, use #localCoverageForClass: instead' ].
	className := self name copyFrom: 1 to: self name size - 'Test' size.
	cls := Smalltalk globals at: className asSymbol ifAbsent: [ self error: 'Please, use #localCoverageForClass: instead' ].
	cls isBehavior
		ifFalse: [ cls := cls class ].
	^ self localCoverageForClass: cls! !

!TestCase class methodsFor: 'coverage' stamp: 'sd 1/28/2009 15:04'!
localCoverageAsString
	| cov className |
	cov := self localCoverage first asInteger. 
	"coverage already checks that the name is ends with 'Test' and if the class tested exists"
	
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	^ self name asString, ' covers ', cov asString, '% of ', className.! !

!TestCase class methodsFor: 'coverage' stamp: 'sd 1/28/2009 14:55'!
localCoverageForClass: cls
	
	| definedMethods testedMethods untestedMethods |
	definedMethods := cls selectors.
	"It happens for IdentityBag / IdentityBagTest"
	definedMethods size = 0
		ifTrue: [^ {0. Set new}].

	testedMethods := 
		self methodDictionary values inject: Set new into: 
							[:sums :cm | sums union: cm messages].
					
	"testedMethods contains all the methods send in test methods, which probably contains methods that have nothign to do with collection"
	testedMethods := testedMethods reject: [:sel | (definedMethods includes: sel) not].

	untestedMethods := definedMethods select: [:selector | (testedMethods includes: selector) not].

	^ { (testedMethods size * 100 / definedMethods size) asFloat . untestedMethods}
! !

!TestCase class methodsFor: 'coverage' stamp: 'sd 1/28/2009 14:55'!
localCoveragePercentage
	^ self localCoverage first! !

!TestCase class methodsFor: 'accessing' stamp: ' 17/7/10 17:28'!
lookupHierarchyRoot
	^TestCase! !

!TestCase class methodsFor: 'initialize - event' stamp: 'al 2/9/2009 20:00'!
methodChanged: anEvent
	"Remove the changed method from the known test results."
	
	| cls sel |
	anEvent item isCompiledMethod ifFalse: [ ^ self ].
	cls := anEvent item methodClass.
	(cls inheritsFrom: TestCase)
		ifFalse: [^ self].
	sel := anEvent item selector.
	(sel beginsWith: 'test')
		ifFalse: [^ self].
	TestResult removeFromTestHistory: sel in: cls.
! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 15:58'!
methodFailed: aSelector
	^ (self lastRun at: #failures) includes: aSelector! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 16:00'!
methodPassed: aSelector
	^ (self lastRun at: #passed) includes: aSelector! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 16:00'!
methodProgressed: aSelector
	^ ((self storedMethodRaisedError: aSelector) or: [self storedMethodFailed: aSelector])
		and: [self methodPassed: aSelector]
		! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 16:00'!
methodRaisedError: aSelector
	^ (self lastRun at: #errors) includes: aSelector! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 16:00'!
methodRegressed: aSelector
	^ (self storedMethodPassed: aSelector) and: [(self methodFailed: aSelector) or: [self methodRaisedError: aSelector]]! !

!TestCase class methodsFor: 'history' stamp: 'StephaneDucasse 7/7/2010 18:41'!
newTestDictionary

	^ Dictionary new at: #timeStamp put: DateAndTime now;
		at: #passed put: Set new;
		at: #failures put: Set new;
		at: #errors put: Set new;
		yourself
		! !

!TestCase class methodsFor: 'events' stamp: 'Alexandre Bergel 7/29/2010 14:36'!
resetAnnouncer
	self announcers removeKey: self ifAbsent: []! !

!TestCase class methodsFor: 'history' stamp: 'Alexandre.Bergel 4/3/2009 14:47'!
resetHistory
	history := nil! !

!TestCase class methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
resources

	^#()! !

!TestCase class methodsFor: 'instance creation' stamp: 'BaseSystem 8/30/2009 09:35'!
run: aSymbol

	^(self selector: aSymbol) run! !

!TestCase class methodsFor: 'instance creation' stamp: 'BaseSystem 8/30/2009 09:35'!
selector: aSymbol

	^self new setTestSelector: aSymbol! !

!TestCase class methodsFor: 'events' stamp: 'Alexandre Bergel 7/29/2010 14:48'!
shouldAnnounce
	^ self announcers includesKey: self! !

!TestCase class methodsFor: 'history' stamp: 'simon.denier 11/13/2008 21:29'!
shouldGenerateLastStoredRunMethod
	| sameRun |
	
	(self class methodDictionary includesKey: #lastStoredRun)
		ifFalse: [^ true].
	sameRun := #(#passed #failures #errors) inject: true into: 
		[ :ok :set | ok and: [(self lastRun at: set) = (self lastStoredRun at: set) ]].
	^ sameRun not
! !

!TestCase class methodsFor: 'testing' stamp: ' 17/7/10 17:28'!
shouldInheritSelectors
	"I should inherit from an Abstract superclass but not from a concrete one by default, unless I have no testSelectors in which case I must be expecting to inherit them from my superclass.  If a test case with selectors wants to inherit selectors from a concrete superclass, override this to true in that subclass."
	
	^self ~~ self lookupHierarchyRoot
		and: [self superclass isAbstract or: [self testSelectors isEmpty]]! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 15:59'!
storedMethodFailed: aSelector
	^ (self lastStoredRun at: #failures) includes: aSelector! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 16:00'!
storedMethodPassed: aSelector
	^ (self lastStoredRun at: #passed) includes: aSelector! !

!TestCase class methodsFor: 'testing' stamp: 'AlexandreBergel 10/21/2008 15:59'!
storedMethodRaisedError: aSelector
	^ (self lastStoredRun at: #errors) includes: aSelector! !

!TestCase class methodsFor: 'instance creation' stamp: 'BaseSystem 8/30/2009 09:35'!
suite

	^self buildSuite! !

!TestCase class methodsFor: 'building suites' stamp: 'BaseSystem 8/30/2009 09:35'!
suiteClass
	^TestSuite! !

!TestCase class methodsFor: 'accessing' stamp: ' 17/7/10 17:28'!
sunitVersion
	^'4.0'! !

!TestCase class methodsFor: 'accessing' stamp: 'NiallRoss 7/18/2010 11:38'!
testSelectors
	^(self selectors select: [ :each | (each beginsWith: 'test') and: [each numArgs isZero]])! !

!TestCase methodsFor: 'dependencies' stamp: 'BaseSystem 8/30/2009 09:35'!
addDependentToHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"! !

!TestCase methodsFor: 'events' stamp: 'Alexandre Bergel 8/2/2010 11:57'!
announce: anAnnouncementClass
	^ self announce: anAnnouncementClass with: nil! !

!TestCase methodsFor: 'events' stamp: 'tbn 4/26/2011 09:58'!
announce: anAnnouncementClass withResult: result
	| event |
	self shouldAnnounce ifFalse: [ ^ self ].
	
	event := anAnnouncementClass asAnnouncement.
	event testCase: self.
	event testSelector: testSelector.
	event testResult: result.
	self announcer announce: event.! !

!TestCase methodsFor: 'events' stamp: 'Alexandre Bergel 7/29/2010 14:48'!
announcer
	^ self class announcer! !

!TestCase methodsFor: 'asserting' stamp: 'jannik.laval 5/2/2010 07:06'!
assert: aBoolean

	aBoolean ifFalse: [self signalFailure: 'Assertion failed']
			! !

!TestCase methodsFor: 'asserting' stamp: 'md 8/2/2006 11:00'!
assert: aBooleanOrBlock description: aString
	aBooleanOrBlock value ifFalse: [
		self logFailure: aString.
		TestResult failure signal: aString]
			! !

!TestCase methodsFor: 'asserting' stamp: 'md 8/2/2006 11:00'!
assert: aBooleanOrBlock description: aString resumable: resumableBoolean 
	| exception |
	aBooleanOrBlock value
		ifFalse: 
			[self logFailure: aString.
			exception := resumableBoolean
						ifTrue: [TestResult resumableFailure]
						ifFalse: [TestResult failure].
			exception signal: aString]
			! !

!TestCase methodsFor: 'asserting' stamp: 'SeanDeNigris 6/23/2012 22:56'!
assert: actual equals: expected
	^ self
		assert: expected = actual
		description: (self comparingStringBetween: actual and: expected)! !

!TestCase methodsFor: 'private' stamp: 'AdrianLienhard 10/19/2009 12:07'!
cleanUpInstanceVariables
	self class allInstVarNames do: [ :name |
		name = 'testSelector' ifFalse: [
			self instVarNamed: name put: nil ] ]! !

!TestCase methodsFor: 'private' stamp: 'SeanDeNigris 6/23/2012 22:57'!
comparingStringBetween: actual and: expected
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Expected ';
			nextPutAll: (expected printStringLimitedTo: 10);
			nextPutAll: ' but was ';
			nextPutAll: (actual printStringLimitedTo: 10);
			nextPutAll: '.']! !

!TestCase methodsFor: 'running' stamp: 'NiallRoss 7/18/2010 11:52'!
debug
	[(self class selector: testSelector) runCase]
		ensure: [TestResource resetResources: self resources]! !

!TestCase methodsFor: 'running' stamp: 'nfr 1/3/2010 18:04'!
debugAsFailure
	| semaphore |
	semaphore := Semaphore new.
	[semaphore wait.
	TestResource resetResources: self resources] fork.
	(self class selector: testSelector) runCaseAsFailure: semaphore! !

!TestCase methodsFor: 'asserting' stamp: 'jannik.laval 5/2/2010 07:16'!
deny: aBoolean

	self assert: aBoolean not
			! !

!TestCase methodsFor: 'asserting' stamp: 'md 8/2/2006 11:00'!
deny: aBooleanOrBlock description: aString
	self assert: aBooleanOrBlock value not description: aString
			! !

!TestCase methodsFor: 'asserting' stamp: 'md 8/2/2006 11:00'!
deny: aBooleanOrBlock description: aString resumable: resumableBoolean 
	self
		assert: aBooleanOrBlock value not
		description: aString
		resumable: resumableBoolean
			! !

!TestCase methodsFor: 'private' stamp: 'md 2/22/2006 14:27'!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: true]
			! !

!TestCase methodsFor: 'private' stamp: 'md 2/22/2006 14:27'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) ]
			! !

!TestCase methodsFor: 'private' stamp: 'md 2/22/2006 14:27'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) not ]
			! !

!TestCase methodsFor: 'extensions' stamp: 'mx 3/20/2006 23:32'!
executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock

	^[aBlock value.
 	false] 
		on: anException
		do: [:exception | 
			anotherBlock value: exception.
			exception return: true]! !

!TestCase methodsFor: 'testing' stamp: 'MarcusDenker 8/1/2011 10:57'!
expectedFailures
	| pragmas |
	^ expectedFails ifNil: [
		
		pragmas := Pragma allNamed: #expectedFailure from: self class to: TestCase.
		expectedFails := pragmas collect: [:each | each method selector  ].
	]	
! !

!TestCase methodsFor: 'extensions' stamp: 'mx 3/13/2006 23:21'!
fail

	^self assert: false! !

!TestCase methodsFor: 'running' stamp: 'md 2/22/2006 14:17'!
failureLog	
	^Transcript

			! !

!TestCase methodsFor: 'running' stamp: ''!
isLogging
	"By default, we're not logging failures. If you override this in 
	a subclass, make sure that you override #failureLog"
	^false
			! !

!TestCase methodsFor: 'running' stamp: ''!
logFailure: aString
	self isLogging ifTrue: [
		self failureLog 
			cr; 
			nextPutAll: aString; 
			flush]
			! !

!TestCase methodsFor: 'running' stamp: 'BaseSystem 8/30/2009 09:35'!
openDebuggerOnFailingTestMethod
	"SUnit has halted one step in front of the failing test method. Step over the 'self halt' and 
	 send into 'self perform: testSelector' to see the failure from the beginning"

	self
		halt;
		performTest! !

!TestCase methodsFor: 'private' stamp: 'NiallRoss 7/18/2010 12:59'!
performTest
	self perform: testSelector asSymbol! !

!TestCase methodsFor: 'running' stamp: 'HernanWilkinson 9/30/2010 14:00'!
prepareToRunAgain 	

	"Used by the debugger when a test is restarted
	I'm not 'hidding'' possible exceptions because I think it is best to popup a new debugger
	if some one occurs and let the programmer decide what to do - Hernan"
	self 
		tearDown;
		setUp! !

!TestCase methodsFor: 'printing' stamp: 'BaseSystem 8/30/2009 09:35'!
printOn: aStream

	aStream
		nextPutAll: self class printString;
		nextPutAll: '>>#';
		nextPutAll: testSelector! !

!TestCase methodsFor: 'dependencies' stamp: 'BaseSystem 8/30/2009 09:35'!
removeDependentFromHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"! !

!TestCase methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
resources
	"We give TestCase this instance-side method so that methods polymorphic with TestSuite can be code-identical.  Having this instance-side method also helps when writing tests of resource behaviour. Except for such tests, it is rare to override this method and should not be done without thought.  If there were a good reason why a single test case needed to share tests requiring different resources, it might be legitimate."

	^self class resources! !

!TestCase methodsFor: 'running' stamp: 'NiallRoss 7/18/2010 11:53'!
run
	| result |
	result := TestResult new.
	[self run: result]
		ensure: [TestResource resetResources: self resources].
	^result! !

!TestCase methodsFor: 'running' stamp: 'BaseSystem 8/30/2009 09:35'!
run: aResult
	aResult runCase: self! !

!TestCase methodsFor: 'running' stamp: 'jannik.laval 10/1/2010 12:39'!
runCase
	self resources do: [:each | each availableFor: self].
	[self setUp.
	self performTest] ensure: [
		self tearDown.
		self cleanUpInstanceVariables]! !

!TestCase methodsFor: 'running' stamp: 'NiallRoss 7/18/2010 11:53'!
runCaseAsFailure: aSemaphore
	[self resources do: [:each | each availableFor: self].
	[self setUp.
	self openDebuggerOnFailingTestMethod] ensure: [self tearDown]]
		ensure: [aSemaphore signal]! !

!TestCase methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
selector
	^testSelector! !

!TestCase methodsFor: 'private' stamp: 'BaseSystem 8/30/2009 09:35'!
setTestSelector: aSymbol
	testSelector := aSymbol! !

!TestCase methodsFor: 'running' stamp: 'DavidRoethlisberger 11/10/2008 09:54'!
setUp! !

!TestCase methodsFor: 'deprecated' stamp: 'BaseSystem 8/30/2009 09:35'!
should: aBlock
	self assert: aBlock value! !

!TestCase methodsFor: 'deprecated' stamp: 'BaseSystem 8/30/2009 09:35'!
should: aBlock description: aString
	self assert: aBlock value description: aString! !

!TestCase methodsFor: 'extensions' stamp: 'IgorStasenko 7/28/2011 11:13'!
should: aBlock notTakeMoreThan: aDuration
    "Evaluate aBlock and if it takes more than given duration
    to run we report a test failure. "

	^ aBlock valueWithin: aDuration onTimeout: [
		self 
			assert: false 
			description: ('Block evaluation took more than the expected <1p>' expandMacrosWith: aDuration)
	]
	
! !

!TestCase methodsFor: 'extensions' stamp: 'md 8/2/2006 11:08'!
should: aBlock notTakeMoreThanMilliseconds: anInteger
    "For compatibility with other Smalltalks"

   self should: aBlock notTakeMoreThan: (Duration milliSeconds: anInteger).! !

!TestCase methodsFor: 'asserting' stamp: ''!
should: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
			! !

!TestCase methodsFor: 'asserting' stamp: ''!
should: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
		description: aString
			! !

!TestCase methodsFor: 'asserting' stamp: 'nk 5/11/2003 10:32'!
should: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString)
		description: aString
! !

!TestCase methodsFor: 'asserting' stamp: 'nk 5/11/2003 10:24'!
should: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString)
		description: aString
! !

!TestCase methodsFor: 'extensions' stamp: 'mx 3/20/2006 23:52'!
should: aBlock raise: anException withExceptionDo: anotherBlock 

	^self assert: (self executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock)! !

!TestCase methodsFor: 'events' stamp: 'Alexandre Bergel 7/29/2010 14:47'!
shouldAnnounce
	^ self class shouldAnnounce! !

!TestCase methodsFor: 'extensions' stamp: 'mx 3/20/2006 21:29'!
shouldFix: aBlock 

	^self should: aBlock raise: Exception! !

!TestCase methodsFor: 'testing' stamp: 'JF 7/30/2003 13:39'!
shouldPass
	"Unless the selector is in the list we get from #expectedFailures, we expect it to pass"
	^ (self expectedFailures includes: testSelector) not! !

!TestCase methodsFor: 'deprecated' stamp: 'BaseSystem 8/30/2009 09:35'!
shouldnt: aBlock
	self deny: aBlock value! !

!TestCase methodsFor: 'deprecated' stamp: 'BaseSystem 8/30/2009 09:35'!
shouldnt: aBlock description: aString
	self deny: aBlock value description: aString! !

!TestCase methodsFor: 'asserting' stamp: ''!
shouldnt: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not
			! !

!TestCase methodsFor: 'asserting' stamp: ''!
shouldnt: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not 		description: aString
			! !

!TestCase methodsFor: 'asserting' stamp: 'nk 5/11/2003 10:34'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString) not
		description: aString
! !

!TestCase methodsFor: 'asserting' stamp: 'nk 5/11/2003 10:34'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString) not
		description: aString
! !

!TestCase methodsFor: 'asserting' stamp: 'md 2/22/2006 14:26'!
signalFailure: aString
	TestResult failure signal: aString! !

!TestCase methodsFor: 'running' stamp: 'jannik.laval 10/1/2010 12:39'!
tearDown

	! !

TestAsserter subclass: #TestResource
	instanceVariableNames: 'name description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

TestResource class
	instanceVariableNames: 'current'!

!TestResource commentStamp: '<historical>' prior: 0!
Normally a test will set up all the objects it needs and tear them down again after it has run.  This self-containedness makes a test more robust.  Use TestResources only for objects that are needed by several tests and that are too 'expensive' (in time or otherwise) to recreate and destroy for each test.  A viable approach is to develop the code in MyTestCase's #setUp and #tearDown methods, then at some point refactor the code into the #setUp and #tearDown of a TestResource whose class is added to MyTestCase class>>resource method.

TestResource uses the singleton pattern.  A TestResource class will set up a single instance of itself when first requested and tear it down again at the end of TestSuite>>run (or TestCase>>run, >>debug and >>debugAsFailure).  Normally, a TestResource, once setUp, remains active during the running of all remaining tests and is #reset after all tests have run.  For an exception, see subclass CompetingResource in SUnitResourcePatterns.  Users can choose to #reset a resource in the #tearDown of a test that alters it, sacrificing the performance gain of having a single #setUp of the resource for the certainty that other tests using it will not see the alterations.  Generally however, this should be the exception:  if you need to reset the resource for every test that uses it, its code should just be part of your test's #setUp and #tearDown code.

To use, create a subclass of TestResource and override the following:
	- TestCase class>>resources, to return a collection including the TestResource class, for all test case classes that need it
		* a TestCase' resources are set up in the order returned and torn down in the reverse order
	- TestResource class>>resources, if the resource itself always needs some other resource to be present before it can set up
		* a TestResource's resource are set up before it and torn down after it, and are set up in the order returned and torn down in the reverse order
	- TestResource>>setUp and tearDown, to define initial and final behaviour (just like a test)
	- TestResource>>isAvailable, to return true if it is and false if it isn't (the framework calls this after setUp);  ideally, this call should not change the resource' state - that should be done in setUp

TestResource implements the singleton pattern in its class-side #isAvailable and #reset methods.  Do not override these when creating specific resources;  unless you are developing a whole new pattern of use, it will always be correct to override instance-side #setUp, #tearDown and #isAvailable, and dangerous to override class>>isAvailable, class>>isAlreadyAvailable and class>>reset.

Generally, users do not code interactions with a test's resources during the running of a test.  Code that reads a resource' values while leaving its state strictly alone is safe enough.  A test must leave a resource in a clean state:  always use #reset if a test must protect later-running tests from unsafe changes (and review whether in such a case a resource is the right thing to use in the first place).

See my superclass' comment for assertion and logging information.
!

TestResource class
	instanceVariableNames: 'current'!

!TestResource class methodsFor: 'running' stamp: ' 17/7/10 17:28'!
availableFor: aTestAsserter
	aTestAsserter
		assert: self isAvailable
		description:
			'Unavailable resource ' , self name , ' requested by '
				, aTestAsserter printString! !

!TestResource class methodsFor: 'accessing' stamp: ' 17/7/10 17:28'!
current
	"This is a lazy accessor:  the assert of self isAvailable does no work unless current isNil.  However this method should normally be sent only to a resource that should already have been made available, e.g. in a test whose test case class has the resource class in its #resources, so should never be able to fail the assert.
	If the intent is indeed to access a possibly-unprepared or reset-in-earlier-test resource lazily, then preface the call of 'MyResource current' with 'MyResource availableFor: self'."
	
	self
		assert: self isAvailable
		description:
			'Sent #current to unavailable resource ' , self name ,
					'.  Add it to test case'' class-side #resources (recommended) or send #availableFor: beforehand'.
	^current! !

!TestResource class methodsFor: 'accessing' stamp: ''!
current: aTestResource

	current := aTestResource
			! !

!TestResource class methodsFor: 'testing' stamp: 'md 2/22/2006 14:21'!
isAbstract
	"Override to true if a TestResource subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #TestResource
			! !

!TestResource class methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
isAlreadyAvailable
	^current class == self! !

!TestResource class methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
isAvailable
	"This is (and must be) a lazy method.  If my current has a value, an attempt to make me available has already been made:  trust its result.  If not, try to make me available."

	current isNil ifTrue: [self makeAvailable].
	^self isAlreadyAvailable! !

!TestResource class methodsFor: 'testing' stamp: ''!
isUnavailable

	^self isAvailable not
			! !

!TestResource class methodsFor: 'private' stamp: 'GuillermoPolito 4/10/2011 21:30'!
makeAvailable
	"This method must be the _only_ way to set a notNil value for the unique instance (current).  First, obtain a candidate instance and set current to a notNil placeholder (any notNil object not an instance of me would do;  this version uses false).  Next, check any subordinate resources needed by this resource.  Lastly, setUp the candidate and put it in current if it is available, ensuring that it is torn down otherwise."
	
	| candidate |
	current := nil.
	candidate := self new.
	self resources do: [:each | each availableFor: candidate].
	[candidate setUp.
	candidate isAvailable ifTrue: [current := candidate]]
		ensure: [current == candidate ifFalse: [candidate tearDown]]! !

!TestResource class methodsFor: 'instance creation' stamp: 'nfr 1/3/2010 18:01'!
new
	"Use #current to get the valid current instance.  Use of #new to get an instance (that should never be the current one) could be done in bizarre circumstances, so is not blocked, but will usually be inappropriate."
	
	^super new initialize.! !

!TestResource class methodsFor: 'instance creation' stamp: 'NiallRoss 7/18/2010 11:53'!
reset
	[self isAlreadyAvailable ifTrue: [current tearDown]]
		ensure: [current := nil]! !

!TestResource class methodsFor: 'private' stamp: 'nfr 1/3/2010 18:00'!
resetOrAddResourcesTo: aCollection
	"Add correctly set-up resources to the collection unless already there. Reset any imperfectly-set-up resources, so current isNil will return true if they are re-encountered via an indirectly self-prerequing resource;  circular references cannot be set up so will never reply true to isAlreadyAvailable, but may have correctly-set-up prereqs to add and/or imperfectly-set-up ones to reset, so do not abort the loop first time round."

	current isNil ifTrue: [^self].
	self isAlreadyAvailable
		ifFalse:
			[self reset.
			self resources do: [:each | each resetOrAddResourcesTo: aCollection]]
		ifTrue:
			[(aCollection includes: self)
				ifFalse:
					[self resources do: [:each | each resetOrAddResourcesTo: aCollection].
					aCollection add: self]]

"The cloned 'self resources do: ...' line in both blocks is, I think, the best way to write this method so that its logic is clear.  The first loop resets this resource immediately, before traversing its resources;  the second traverses before adding"! !

!TestResource class methodsFor: 'running' stamp: 'nfr 1/3/2010 18:01'!
resetResources: topLevelResources
	"Reset all imperfectly-set-up resources while gathering the rest for ordered resetting."

	| availableResources |
	availableResources := OrderedCollection new: topLevelResources size.
	topLevelResources
		do: [:each | each resetOrAddResourcesTo: availableResources].
	availableResources reverseDo: [:each | each reset]! !

!TestResource class methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
resources
	^#()! !

!TestResource methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
description

	description isNil
		ifTrue: [^''].

	^description! !

!TestResource methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
description: aString

	description := aString! !

!TestResource methodsFor: 'initialize-release' stamp: ' 17/7/10 17:28'!
initialize
	"This method used to call setUp but now does nothing;  setUp is called by the framework at the appropriate point.  Subclasses may override to set the object to its default state."
	
	! !

!TestResource methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
isAvailable
	"Override to provide information on the readiness of the resource.  Put state-changing behaviour in setUp and keep this a state-preserving check as far as possible.  Where setUp is guaranteed to provide a valid resource if it completes, there is no need to override this."
	
	^true! !

!TestResource methodsFor: 'testing' stamp: ''!
isUnavailable
	"override to provide information on the
	readiness of the resource"
	
	^self isAvailable not
			! !

!TestResource methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
name

	name isNil
		ifTrue: [^self printString].

	^name! !

!TestResource methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
name: aString

	name := aString! !

!TestResource methodsFor: 'printing' stamp: 'BaseSystem 8/30/2009 09:35'!
printOn: aStream

	aStream nextPutAll: self class printString! !

!TestResource methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
resources
	^self class resources! !

!TestResource methodsFor: 'running' stamp: 'BaseSystem 8/30/2009 09:35'!
setUp
	"Does nothing. Subclasses should override this to initialize their resource"! !

!TestResource methodsFor: 'running' stamp: 'BaseSystem 8/30/2009 09:35'!
tearDown
	"Does nothing. Subclasses should override this to tear down their resource"! !

Object subclass: #TestResult
	instanceVariableNames: 'timeStamp failures errors passed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

!TestResult commentStamp: '<historical>' prior: 0!
This implements the Collecting Parameter pattern for running a bunch of tests.  It holds tests that have run, sorted into the result categories of passed, failures and errors.

TestResult is an interesting object to subclass or substitute. #runCase: is the external protocol you need to reproduce. TestResult subclasses can  handle multi-threaded tests (see SUnitXProcPatterns) and might record coverage information or send emails when the run completes.
!

!TestResult class methodsFor: 'exceptions' stamp: 'BaseSystem 8/30/2009 09:35'!
error
	^self exError! !

!TestResult class methodsFor: 'exceptions' stamp: 'md 2/22/2006 14:17'!
exError
	^Error
			! !

!TestResult class methodsFor: 'exceptions' stamp: 'BaseSystem 8/30/2009 09:35'!
failure
	^TestFailure! !

!TestResult class methodsFor: 'history' stamp: 'Alexandre.Bergel 4/3/2009 14:44'!
historyAt: aTestCaseClass
"I will return the last test dictionary for aTestCaseClass. If none found, I will create a new empty one and link it in the history."

	^ aTestCaseClass history ! !

!TestResult class methodsFor: 'history' stamp: 'Alexandre.Bergel 4/3/2009 14:45'!
historyAt: aTestCaseClass put: aDictionary
	aTestCaseClass history: aDictionary
	"^ self history at: aTestCaseClass put: aDictionary "! !

!TestResult class methodsFor: 'history' stamp: 'Alexandre.Bergel 4/3/2009 14:46'!
historyFor: aTestCaseClass
	"I return the last test dictionary for aTestCaseClass. 
	If none found, I return an empty dictionary but will not link it to the class in the history."
	
	| history |
	history := aTestCaseClass history.
	history ifNil: [ ^ self newTestDictionary ].
	^ history
	
"	^ self history at: aTestCaseClass ifAbsent: [ self newTestDictionary ]"! !

!TestResult class methodsFor: 'history' stamp: 'StephaneDucasse 7/7/2010 18:41'!
newTestDictionary

	^ Dictionary new at: #timeStamp put: DateAndTime now;
		at: #passed put: Set new;
		at: #failures put: Set new;
		at: #errors put: Set new;
		yourself
		! !

!TestResult class methodsFor: 'history' stamp: 'simon.denier 11/22/2008 20:56'!
removeFromTestHistory: aSelector in: aTestCaseClass
	| lastRun |
	
	lastRun := self historyFor: aTestCaseClass.
	#(#passed #failures #errors) do:
		[ :set | (lastRun at: set) remove: aSelector ifAbsent: []].
! !

!TestResult class methodsFor: 'exceptions' stamp: 'BaseSystem 8/30/2009 09:35'!
resumableFailure
	^ResumableTestFailure! !

!TestResult class methodsFor: 'exceptions' stamp: 'md 2/22/2006 14:26'!
signalErrorWith: aString 
	self error signal: aString
			! !

!TestResult class methodsFor: 'exceptions' stamp: 'md 2/22/2006 14:26'!
signalFailureWith: aString 
	self failure signal: aString
			! !

!TestResult class methodsFor: 'history' stamp: 'BenjaminVanRyseghem 10/2/2011 17:05'!
updateTestHistoryFor: aTestCase status: aSymbol
	| cls sel |
	
	cls := aTestCase class.
	sel := aTestCase selector.
	self removeFromTestHistory: sel in: cls.
	((self historyAt: cls) at: aSymbol ) add: sel.
	TestAnnouncer announcer announce: (TestSuiteEnded result: aTestCase class)! !

!TestResult methodsFor: 'adding' stamp: 'NiallRoss 7/18/2010 12:21'!
addError: aTestCase
	"We cannot use self errors as that incorporates test expectations and so does not return the stored collection."

	^errors add: aTestCase! !

!TestResult methodsFor: 'adding' stamp: 'NiallRoss 7/18/2010 12:21'!
addFailure: aTestCase
	"We cannot use self failures as that incorporates test expectations and so does not return the stored collection."

	^failures add: aTestCase! !

!TestResult methodsFor: 'adding' stamp: 'NiallRoss 7/18/2010 12:22'!
addPass: aTestCase
	"We cannot use self passed as that incorporates test expectations and so does not return the stored collection."

	^passed add: aTestCase! !

!TestResult methodsFor: 'accessing' stamp: 'simon.denier 11/13/2008 20:27'!
classesTested
	^ (self tests collect: [ :testCase | testCase class ]) asSet! !

!TestResult methodsFor: 'deprecated' stamp: 'nfr 1/3/2010 17:58'!
correctCount
	"deprecated - use #passedCount"
	
	^self passedCount! !

!TestResult methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
defects
	^OrderedCollection new
		addAll: self errors;
		addAll: self failures; yourself! !

!TestResult methodsFor: 'diff' stamp: 'AlexandreBergel 10/1/2008 16:26'!
diff: aTestResult
	"Return a collection that contains differences"
	| passed1Selectors failed1Selectors errors1Selectors passed2Selectors failed2Selectors errors2Selectors |
	passed1Selectors := self passed collect: [:testCase | testCase selector].
	failed1Selectors := self failures collect: [:testCase | testCase selector].
	errors1Selectors := self errors collect: [:testCase | testCase selector].

	passed2Selectors := aTestResult passed collect: [:testCase | testCase selector].
	failed2Selectors := aTestResult failures collect: [:testCase | testCase selector].
	errors2Selectors := aTestResult errors collect: [:testCase | testCase selector].
	
	^ {passed1Selectors copyWithoutAll: passed2Selectors .
		failed1Selectors copyWithoutAll: failed2Selectors .
		errors1Selectors copyWithoutAll: errors2Selectors}! !

!TestResult methodsFor: 'history' stamp: 'simon.denier 11/13/2008 20:33'!
dispatchResultsIntoHistory 

	self classesTested do: 
		[ :testClass | 
		self class
			historyAt: testClass
			put: (self selectResultsForTestCase: testClass) ].
! !

!TestResult methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
errorCount

	^self errors size! !

!TestResult methodsFor: 'compatibility' stamp: 'JF 7/30/2003 16:09'!
errors
	^ self unexpectedErrors! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
expectedDefectCount
	^ self expectedDefects size! !

!TestResult methodsFor: 'accessing' stamp: 'md 11/25/2004 16:36'!
expectedDefects
	^ (errors, failures asOrderedCollection) select: [:each | each shouldPass not] ! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
expectedPassCount
	^ self expectedPasses size! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
expectedPasses
	^ passed select: [:each | each shouldPass] ! !

!TestResult methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
failureCount

	^self failures size! !

!TestResult methodsFor: 'compatibility' stamp: 'md 11/25/2004 16:23'!
failures
	^ self unexpectedFailures, self unexpectedPasses ! !

!TestResult methodsFor: 'filein/out' stamp: 'LaurentLaffont 5/23/2010 09:54'!
fileOutOn: aFileStream
	"Write in aFileStream like:
	3 run, 2 passes, 0 expected failures, 1 failures, 0 errors, 0 unexpected passes
	Failures:
	SHParserST80Test>>#testNumbers
	
	Errors:"	
	| printer |
	printer := [:title :testCases | 
				aFileStream cr; nextPutAll: title; cr.
				testCases do: [:aTestCase| 
								aTestCase printOn: aFileStream.
								aFileStream cr]].
				
	self printOn: aFileStream.	
	printer value: 'Failures:' value: self failures.
	printer value: 'Errors:' value: self errors.! !

!TestResult methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
hasErrors

	^self errors size > 0! !

!TestResult methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
hasFailures

	^self failures size > 0! !

!TestResult methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
hasPassed

	^self hasErrors not and: [self hasFailures not]! !

!TestResult methodsFor: 'initialization' stamp: 'StephaneDucasse 7/7/2010 18:41'!
initialize
	super initialize.
	passed := OrderedCollection new.
	failures := Set new.
	errors := OrderedCollection new.
	timeStamp := DateAndTime now! !

!TestResult methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
isError: aTestCase

	^self errors includes: aTestCase! !

!TestResult methodsFor: 'querying' stamp: 'GwenaelCasaccio 10/1/2008 22:37'!
isErrorFor: class selector: selector
	^ self errors anySatisfy: [:testCase | testCase class == class and: [testCase selector == selector]]! !

!TestResult methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
isFailure: aTestCase
	^self failures includes: aTestCase! !

!TestResult methodsFor: 'querying' stamp: 'GwenaelCasaccio 10/1/2008 22:37'!
isFailureFor: class selector: selector
	^ self failures anySatisfy: [:testCase | testCase class == class and: [testCase selector == selector]]! !

!TestResult methodsFor: 'testing' stamp: 'BaseSystem 8/30/2009 09:35'!
isPassed: aTestCase

	^self passed includes: aTestCase! !

!TestResult methodsFor: 'querying' stamp: 'GwenaelCasaccio 10/1/2008 22:36'!
isPassedFor: class selector: selector
	^ self passed anySatisfy: [:testCase | testCase class == class and: [testCase selector == selector]]! !

!TestResult methodsFor: 'compatibility' stamp: 'JF 7/30/2003 16:08'!
passed
	^ self expectedPasses, self expectedDefects! !

!TestResult methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
passedCount

	^self passed size! !

!TestResult methodsFor: 'printing' stamp: 'EstebanLorenzano 11/11/2010 16:26'!
printOn: aStream
	aStream
		nextPutAll: self runCount printString;
		nextPutAll: ' run, ';
		nextPutAll: self expectedPassCount printString;
		nextPutAll: ' passes, ';
		nextPutAll: self expectedDefectCount printString;
		nextPutAll:' expected failures, ';
		nextPutAll: self unexpectedFailureCount printString;
		nextPutAll: ' failures, ';
		nextPutAll: self unexpectedErrorCount printString;
		nextPutAll:' errors, ';
		nextPutAll: self unexpectedPassCount printString;
		nextPutAll:' unexpected passes'.! !

!TestResult methodsFor: 'running' stamp: 'BenjaminVanRyseghem 9/27/2011 14:27'!
runCase: aTestCase
	[
	aTestCase announce: TestCaseStarted withResult: self.
	aTestCase runCase.
	aTestCase announce: TestCaseEnded  withResult: self.
	self addPass: aTestCase]
		on: self class failure , Warning, self class error
		do: [:ex | ex sunitAnnounce: aTestCase toResult: self]! !

!TestResult methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
runCount

	^self passedCount + self failureCount + self errorCount! !

!TestResult methodsFor: 'history' stamp: 'simon.denier 11/13/2008 20:51'!
selectResultsForTestCase: aTestCaseClass
	| passedSelectors errorsSelectors failuresSelectors |
	passedSelectors := self passed
						select: [:testCase | testCase class == aTestCaseClass ] thenCollect: [:testCase | testCase selector].
	errorsSelectors := self errors 
						select: [:testCase | testCase class == aTestCaseClass ] thenCollect:  [:testCase | testCase selector].
	failuresSelectors := self failures 
						select: [:testCase | testCase class == aTestCaseClass ] thenCollect:  [:testCase | testCase selector].
	
	^ self class newTestDictionary 
		at: #passed put: passedSelectors asSet;
		at: #failures put: failuresSelectors asSet;
		at: #errors put: errorsSelectors asSet;
		yourself
		! !

!TestResult methodsFor: 'accessing' stamp: 'NiallRoss 7/18/2010 12:51'!
tests
	^(OrderedCollection new: self runCount)
		addAll: passed;
		addAll: failures;
		addAll: errors;
		yourself! !

!TestResult methodsFor: 'accessing' stamp: 'AlexandreBergel 10/1/2008 11:52'!
timeStamp
	^ timeStamp! !

!TestResult methodsFor: 'accessing' stamp: 'AlexandreBergel 10/1/2008 11:52'!
timeStamp: anObject
	timeStamp := anObject! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
unexpectedErrorCount
	^ self unexpectedErrors size! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
unexpectedErrors
	^ errors select: [:each | each shouldPass] ! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
unexpectedFailureCount
	^ self unexpectedFailures size! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
unexpectedFailures
	^ failures select: [:each | each shouldPass] ! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 13:54'!
unexpectedPassCount
	^ self unexpectedPasses size! !

!TestResult methodsFor: 'accessing' stamp: 'JF 7/30/2003 16:14'!
unexpectedPasses
	^ passed select: [:each | each shouldPass not] ! !

!TestResult methodsFor: 'history' stamp: 'simon.denier 11/22/2008 22:05'!
updateResultsInHistory
	
	#(#passed #failures #errors) do: [ :status | 
		(self perform: status) do: [ :testCase | 
			self class updateTestHistoryFor: testCase status: status ] ]! !

Object subclass: #TestSuite
	instanceVariableNames: 'tests resources name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Kernel'!

!TestSuite commentStamp: '<historical>' prior: 0!
This is a Composite of Tests, either TestCases or other TestSuites. The top-level protocol is #run.  This creates aTestResult and sends
	self run: aTestResult.
then ensures that any TestResources made available during the run are reset.  These, and the dependencies protocol, are common between this and TestCase.!

!TestSuite class methodsFor: 'instance creation' stamp: 'BaseSystem 8/30/2009 09:35'!
named: aString

	^self new
		name: aString;
		yourself! !

!TestSuite methodsFor: 'dependencies' stamp: 'md 2/22/2006 14:24'!
addDependentToHierachy: anObject
	self addDependent: anObject.
	self tests do: [ :each | each addDependentToHierachy: anObject]
			! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
addTest: aTest
	self tests add: aTest! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
addTests: aCollection 
	aCollection do: [:eachTest | self addTest: eachTest]! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
defaultResources
	^self tests
		inject: OrderedCollection new
		into:
			[:coll :testCase |
			testCase resources do:
				[:each |
				(coll includes: each) ifFalse: [coll add: each]].
			coll]! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
name

	^name! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
name: aString

	name := aString! !

!TestSuite methodsFor: 'dependencies' stamp: 'md 2/22/2006 14:24'!
removeDependentFromHierachy: anObject
	self removeDependent: anObject.
	self tests do: [ :each | each removeDependentFromHierachy: anObject]
			! !

!TestSuite methodsFor: 'running' stamp: 'StephaneDucasse 10/2/2010 16:29'!
resourceClass

	^TestResource! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
resources
	resources isNil ifTrue: [resources := self defaultResources].
	^resources! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
resources: someOrderedTestResourceClasses
	"The parameter should understand reverseDo: and should not contain duplicates."

	resources := someOrderedTestResourceClasses! !

!TestSuite methodsFor: 'running' stamp: 'StephaneDucasse 10/2/2010 16:27'!
resultClass

	^ TestResult! !

!TestSuite methodsFor: 'running' stamp: 'StephaneDucasse 10/2/2010 16:29'!
run
	| result |
	result := self resultClass new.
	[self run: result]
		ensure: [self resourceClass resetResources: self resources].
	^result! !

!TestSuite methodsFor: 'running' stamp: 'stephane.ducasse 10/9/2008 18:36'!
run: aResult 
	self tests do: [:each | 
		self changed: each.
		each run: aResult].
			! !

!TestSuite methodsFor: 'accessing' stamp: 'BaseSystem 8/30/2009 09:35'!
tests
	tests isNil ifTrue: [tests := OrderedCollection new].
	^tests! !

SystemAnnouncer subclass: #TestAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Core-Announcements'!

!TestAnnouncer commentStamp: '<historical>' prior: 0!
I am used to externally notify that a test has been run (or a test suite)!

!Error methodsFor: '*SUnit-Core' stamp: 'NiallRoss 7/18/2010 11:59'!
sunitAnnounce: aTestCase toResult: aTestResult
	aTestResult addError: aTestCase.
	self sunitExitWith: false.! !
TestCase initialize!
LongTestCase initialize!
